<?php
class erpapi_hchsafe_matrix_360buy_request_hchsafe extends erpapi_hchsafe_request_hchsafe{

    public function __construct()
    {
        $this->__remote_addr = base_request::get_remote_addr(); 
        if (!$this->__remote_addr) $this->__remote_addr = kernel::single('base_component_request')->get_server('SERVER_ADDR');
        if (!$this->__remote_addr) $this->__remote_addr = '127.0.0.1';

        $this->__host = base_request::get_host();

        $this->__url = strtolower(base_request::get_schema()) . '://' . base_request::get_host() . base_request::get_request_uri();

        $this->__account = kernel::single('desktop_user')->get_name();
    }

    public function send_safe_log($params){
        $title = '发送京东安全规范日志';
        
        $callback = array(
            'class'  =>get_class($this),
            'method' => 'send_safe_log_callback',
            'params' =>  $params,
          );
        return $this->__caller->call(HCHSAFE_ISV_LOG,$params,$callback,$title,10,$params["touch_num"]);
    }
    public function send_safe_log_callback($response, $callback_params){
        return $this->callback($response, $callback_params);
    }

    /**
     * 登录日志
     *
     * @return void
     * @author 
     **/
    public function login($sdf)
    {
        $title = '京东安全规范日志-登录';

        $params = array(
            'account'     => $this->__account,
            'client_ip'   => $this->__remote_addr,   # 商家操作的客户端IP
            'op_time'     => time(),                 # 商家操作时间
            'req_jos_url' => $this->__url,           # ISV的操作请求URL
            'touch_num'   => 'NULL',                 # 操作涉及的订单编号
            'touch_field' => 'NULL',                 # 操作涉及的订单字段
            'operation'   => '商家登录ERP系统'.($_SESSION['error'] ? '失败' : '成功'),
        );

        $callback = array(
            'class'  =>get_class($this),
            'method' => 'callback',
        );

        return $this->__caller->call(HCHSAFE_ISV_LOG,$params,$callback,$title);
    }

    public function orderdata($sdf)
    {
        $title = '京东安全规范日志-订单访问';

        $params = array(
            'account'     => $this->__account,
            'client_ip'   => $this->__remote_addr,   # 商家操作的客户端IP
            'op_time'     => time(),                 # 商家操作时间
            'req_jos_url' => $this->__url,           # ISV的操作请求URL
            'touch_num'   => implode(',',(array)$sdf['tradeIds']),                 # 操作涉及的订单编号
            'touch_field' => 'order_bn',                 # 操作涉及的订单字段
            'operation'   => $sdf['operation'],
        );

        $callback = array(
            'class'  =>get_class($this),
            'method' => 'callback',
        );

        return $this->__caller->call(HCHSAFE_ISV_LOG,$params,$callback,$title);
    }

    public function orderpush($sdf)
    {
        $title = '京东安全规范日志-订单推送第三方';

        $params = array(
            'account'     => $this->__account,
            'client_ip'   => $this->__remote_addr,   # 商家操作的客户端IP
            'op_time'     => time(),                 # 商家操作时间
            'req_jos_url' => $this->__url,           # ISV的操作请求URL
            'touch_num'   => implode(',',(array)$sdf['tradeIds']),                 # 操作涉及的订单编号
            'touch_field' => 'order_bn',                 # 操作涉及的订单字段
            'operation'   => '订单推送第三方',
        );

        $callback = array(
            'class'  =>get_class($this),
            'method' => 'callback',
        );

        return $this->__caller->call(HCHSAFE_ISV_LOG,$params,$callback,$title);
    }
}
