<?php
class erpapi_hchsafe_matrix_taobao_request_hchsafe extends erpapi_hchsafe_request_hchsafe{

    public function __construct()
    {
        

        $this->__remote_addr = base_request::get_remote_addr(); 
        if (!$this->__remote_addr) $this->__remote_addr = kernel::single('base_component_request')->get_server('SERVER_ADDR');
        if (!$this->__remote_addr) $this->__remote_addr = '127.0.0.1';

        $this->__ati = kernel::single('base_component_request')->get_cookie('_ati');

        $this->__host = base_request::get_host();

        $this->__url = strtolower(base_request::get_schema()) . '://' . base_request::get_host() . base_request::get_request_uri();
        $this->__prefixUname = base_shopnode::node_id('ome') . ':';
    }

    /**
     * 是否已配置MQ
     *
     * @return void
     * @author 
     **/
    private function __is_config_mq()
    {
        $hcsafe_conf = app::get('ome')->getConf('ome.hcsafe.config');

        if ($hcsafe_conf=='true' || $hcsafe_conf==''){
            return true;
        }else{
            return false;
        }
        
    }

    /**
     * 登录日志
     *
     * @return void
     * @author 
     **/
    public function login($sdf)
    {
        if (!$this->__is_config_mq() || !$this->__ati || !trim($sdf['uname'])) return $this->succ();

        $account_type = pam_account::get_account_type('desktop');
        $shopName = app::get('ome')->model('shop')->get_taobao_name();
        $taobao_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'taobao','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');
        if (!$taobao_shop['node_id']) return $this->succ();
        if($account_type === $sdf['type'] && $shopName) {
            $pushData = array(
                'userId'       => $this->__prefixUname.(string)$sdf['uname'],
                'userIp'       => $this->__remote_addr,
                'ati'          => (string)$this->__ati,
                'topAppKey'    => TOP_APP_KEY,
                'appName'      => $this->__host,
                'tid'          => $shopName,
                'loginResult'  => $_SESSION['error'] ? 'fail' : 'success',
                'loginMessage' => $_SESSION['error'] ? $_SESSION['error'] : '登录成功',
                'time'         => $_SESSION['login_time'],
                'to_node_id'    =>$taobao_shop['node_id'],
            );
            $title = '淘宝风控登录日志';
            $rs = $this->__caller->call(HCHSAFE_UPLOAD_LOGIN_LOG,$pushData,array(),$title,10);

            
        }

        return $this->succ();
    }

    /**
     * 订单访问数据
     *
     * @return void
     * @author 
     **/
    public function orderdata($sdf)
    {
        if (!$this->__is_config_mq() || !$this->__ati || !$sdf['tradeIds']) return $this->succ();

        // 过滤掉非淘宝订单
        foreach ((array)$sdf['tradeIds'] as $key => $value) {
            if (!is_numeric($value) || strlen($value) != '16') unset($sdf['tradeIds'][$key]);
        }
        $taobao_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'taobao','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');
        if (!$taobao_shop['node_id']) return $this->succ();
        if (!$sdf['tradeIds']) return $this->succ();

        $uname = kernel::single('desktop_user')->get_login_name();
        $title = '淘宝风控订单访问数据';
        foreach (array_chunk((array)$sdf['tradeIds'], 100) as $value) {
            $pushData = array(
                'userId'    => $this->__prefixUname.$uname,
                'userIp'    => $this->__remote_addr,
                'ati'       => (string)$this->__ati,
                'topAppKey' => TOP_APP_KEY,
                'appName'   => $this->__host,
                'url'       => $this->__url,
                'tradeIds'  => implode(',',$value),
                'operation' => $sdf['operation'],
                'time'      => time(),
                'to_node_id'    =>$taobao_shop['node_id'],
            );

            $rs = $this->__caller->call(HCHSAFE_UPLOAD_ORDER_LOG,$pushData,array(),$title,10);
            
        }

       

        return $this->succ();
    }

    /**
     * SQL
     *
     * @return void
     * @author 
     **/
    public function sql($sdf)
    {
        if (!$this->__is_config_mq() || !$this->__ati || !$sdf['sqls']) return $this->succ();
        $taobao_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'taobao','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');
        if (!$taobao_shop['node_id']) return $this->succ();
        $uname = kernel::single('desktop_user')->get_login_name();

        $pushData = array(
            'userId'    => $this->__prefixUname.$uname,
            'userIp'    => $this->__remote_addr,
            'ati'       => (string) $this->__ati,
            'appName'   => (string) $this->__host,
            'url'       => $this->__url,
            'db'        => DB_HOST,
            'sql'       => implode(';',$sdf['sqls']),
            'to_node_id'    =>$taobao_shop['node_id'],
        );
        $title = '淘宝风控SQL';
        $rs = $this->__caller->call(HCHSAFE_UPLOAD_SQL_LOG,$pushData,array(),$title,10);
          
        return $this->succ();
    }

    /**
     * 订单推送第三方
     *
     * @return void
     * @author 
     **/
    public function orderpush($sdf)
    {
        if (!$this->__is_config_mq() || !$this->__ati || !$sdf['tradeIds']) return $this->succ();
        $taobao_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'taobao','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');
        if (!$taobao_shop['node_id']) return $this->succ();
        // 过滤掉非淘宝订单
        foreach ((array)$sdf['tradeIds'] as $key => $value) {
            if (!is_numeric($value) || strlen($value) != '16') unset($sdf['tradeIds'][$key]);
        }

        if (!$sdf['tradeIds']) return $this->succ();

        $uname = kernel::single('desktop_user')->get_login_name();


        foreach (array_chunk((array)$sdf['tradeIds'], 100) as $value) {
            $pushData = array(
                'userId'    => $this->__prefixUname.$uname,
                'userIp'    => $this->__remote_addr,
                'ati'       => (string)$this->__ati,
                'appName'   => $this->__host,
                'url'       => $this->__url,
                'tradeIds'  => implode(',',(array)$value),
                'sendTo'    => '',
                'node_id'   => $sdf['to_node_id'],
                'to_node_id'   => $taobao_shop['node_id'],
            );
            $title = '淘宝风控订单推送第三方';
            $rs = $this->__caller->call(HCHSAFE_UPLOAD_ORDERSEND_LOG,$pushData,array(),$title,10);
           
        }



        return $this->succ();
    }

    /**
     * 风控
     *
     * @return void
     * @author 
     **/
    public function computerisk()
    {

        if (!$this->__is_config_mq() || !$this->__ati) return $this->succ();

        $taobao_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'taobao','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');

        if (!$taobao_shop['node_id']) return $this->succ();

        $uname = kernel::single('desktop_user')->get_login_name();

        $title = '淘宝风控';
        
        $params = array(
            'userId'     => $this->__prefixUname.$uname,
            'userIp'     => $this->__remote_addr,
            'ati'        => $this->__ati,
            'topAppKey'  => TOP_APP_KEY,
            'appName'    => $this->__host,
            'time'       => time(),
            'to_node_id' => $taobao_shop['node_id'],
        );

        $rs = $this->__caller->call(HCHSAFE_UPLOAD_COMPUTE_RISK,$params,array(),$title,10);

        if ($rs['rsp'] == 'fail') return $this->succ();

         $data = json_decode($rs['data'],true);

        if ($data['result'] == 'success' && $data['risk'] > 0.5) {
            $urlRs = $this->getVerifyUrl(array('to_node_id'=>$taobao_shop['node_id']));

            $msg = '获取短信验证页面失败，' . $urlRs['msg'];
            return $this->error($msg);
        }

        return $this->succ();
    }

    public function getVerifyUrl($sdf) {
        if (!$this->__ati) return $this->error('缺少孔明锁');
        $objDesktopUser = kernel::single('desktop_user');
        $uname = $objDesktopUser->get_login_name();
        $mobile = $objDesktopUser->get_mobile();
        if(empty($mobile)) {
            return $this->error('缺少手机号,请联系超管添加手机号');
        }
        $objSession = kernel::single('base_session');
        $sessionId = $objSession->sess_id();
        $url = 'http://erp-redirect.shopex.cn/index.php?url=' . base64_encode(kernel::base_url(true) . '?ctl=passport&act=login_verify&sess_id='.$sessionId.'&to_node_id='.$sdf['to_node_id']);
        $title = '淘宝获取二次验证url';
        $params = array(
            "sessionId" => $sessionId,
            "mobile" => $mobile,
            "redirectURL" => urlencode($url),
            "userId" => $this->__prefixUname.$uname,
            "userIp" => $this->__remote_addr,
            "ati" => $this->__ati,
            "appId" => TOP_APP_KEY,
            "appName" => $this->__host,
            "time" => time(),
            "to_node_id" => $sdf['to_node_id']
        );

        $rs = $this->__caller->call(HCHSAFE_VERIFY_URL,$params,array(),$title,10);
        
        if ($rs['rsp'] == 'succ') {
            $data = json_decode($rs['data'], true);
            if($data['verifyUrl']) {
                $objSession->set_cookie_expires(0);
                header('Location:'.$data['verifyUrl']);
                exit();
            }
        }
        return $rs;
    }

    public function isVerifyPassed($sdf) {
        $title = '淘宝二次验证是否成功';
        $params = array(
            'token' => $sdf['token'],
            'time' => time(),
            'to_node_id' => $sdf['to_node_id']
        );
        $rs = $this->__caller->call(HCHSAFE_VERIFY_PASSED,$params,array(),$title,10);
        if($rs['data']) {
            $data = json_decode($rs['data'], true);
            if($data['verifyResult'] == 'fail') {
                return $this->error($data['errMsg']);
            }
        }
        return $rs;
    }
}