<?php
/**
 * sunjing@shopex.cn
 * Date: 2016/11/23
 */
class erpapi_logistics_matrix_unionpay_request_electron extends erpapi_logistics_request_electron
{

    public function bufferRequest($sdf){
        return $this->directNum;
    }

    public function directRequest($sdf){
        $this->primaryBn = $sdf['primary_bn'];
        $delivery = $sdf['delivery'];
        $shopInfo = $sdf['shop'];
        $to_address = $delivery['ship_addr'] ? $delivery['ship_province'] . $delivery['ship_city'] . $delivery['ship_district'] . $delivery['ship_addr'] : '_SYSTEM';
     
        $receiver = array(
            'company'   =>  $this->charFilter($delivery['ship_name']),
            'name'      =>  $this->charFilter($delivery['ship_name']),
            'tel'       =>  $delivery['ship_tel'],
            'mobile'    =>  $delivery['ship_mobile'],
            'post_code' =>  $delivery['ship_zip'],
            'province'  =>  $delivery['ship_province'],
            'city'      =>  $delivery['ship_city'],
            'area'      =>  $delivery['ship_district'],
            'address'   =>  $this->charFilter($to_address),
        );
         $area = explode(':',$shopInfo['area']);
         $area = explode('/',$area[1]);  
        $sender = array(
            'company'   =>  $shopInfo['default_sender'] ? $shopInfo['default_sender'] : '_SYSTEM',
            'name'      =>  $shopInfo['default_sender'] ? $shopInfo['default_sender'] : '_SYSTEM',
            'tel'       =>  $shopInfo['tel'],
            'mobile'    =>  $shopInfo['mobile'],
            'post_code' =>  $shopInfo['zip'],
            'province'  =>  $area[0],
            'city'      =>  $area[1],
            'area'      =>  $area[2],
            'address'   =>  $this->charFilter($shopInfo['addr']),
        );

        $params = array(
            //'member_id'     =>  $delivery['member_id'],
            'send_site'     =>  "",  # 收件网点标识
            'shipper_code'  =>  $this->__channelObj->channel['logistics_code'],  # 物流公司编码
            'logistic_code' =>  '',  # 运单号
            'tid'           =>  $delivery['delivery_bn'],  # 订单号
            'cost'          =>  '',
            'other_cost'    =>  '',
            'receiver'      =>  json_encode($receiver),
            'sender'        =>  json_encode($sender),
            'start_date'    =>  '',#上门取货时间段
            'end_date'      =>  '',
            'weight'        =>  '',
            'volume'        =>  '',
            'remark'        =>  '',
            'qty'           =>  '',
            'service_list'  =>  '',#增值服务
            'commoditys'     =>  json_encode($this->format_delivery_item($sdf['delivery_item'])),#货品明细信息
            'device_type' =>'pc',//pos android ios wp qt pc
            'is_auto_bill'  =>'1',
            'exp_type'=>'1',
        );
        $back =   $this->requestCall(SHOP_LOGISTICS_SUBSCRIBE, $params,array(),$sdf);
        return $this->backToResult($back, $delivery);
    }
    #获取货物名称
    public function format_delivery_item($deliveryItems = null) {
        $items = array();
        foreach($deliveryItems as $key=>$item){
            $items[$key]['code']    = $item['bn'];
            $items[$key]['name']    = $item['product_name'];
            $items[$key]['num']     = $item['number'];
            $items[$key]['price']   = $item['price'];//weight desc vol
            $items[$key]['weight']  = $item['weight'];
            $items[$key]['desc']    = $item['desc'];
            $items[$key]['GoodsSku'] = $item['barcode'];
            $items[$key]['vol']     = $item['vol'];
        }
        return $items;
    }

    public function backToResult($back, $delivery){

        $data = empty($back['data']) ? '' : json_decode($back['data'], true);
        $data = empty($data['data']) ? '' :  json_decode($data['data'], true);
        if(empty($data)) {
            return false;
        }
        $msg = '';
        #以下这种情况，说明银联做过特殊处理了，需要在打印页面提示客户
        if($data['UmsbillNo'] && (($data['Success'] == true && empty($data['Order'] ['LogisticCode'])) && empty($data['Reason']))){
            $msg = '单据已推送到仓储';
        }elseif(!empty($data['Reason'])){
            $msg = $data['Reason'];
        }
        $result = array();
        $result[] = array(
            'succ' => $data['Order'] ['LogisticCode']? true : false,
            'msg' => $msg,
            'delivery_id' => $delivery['delivery_id'],
            'delivery_bn' => $delivery['delivery_bn'],
            'logi_no' => $data['Order'] ['LogisticCode'],
            'package_wdjc' => $data['Order'] ['DestinatioName'],
            'package_wd' => $data['Order'] ['DestinatioCode'],
        );
        $this->directDataProcess($result);
        return $result;
    }

    public function recycleWaybill($waybillNumber) {
        
        $this->title = '银联_' . $this->__channelObj->channel['logistics_code'] . '取消电子面单';
        $this->primaryBn = $waybillNumber;
        $params = array(
            'order_id' => $waybillNumber,
            'shipper_code'=>  $this->__channelObj->channel['logistics_code'],
             'is_auto_bill'  =>'1',
            'device_type' =>'pc',
            'exp_type'=>'1',
        );
        
        $this->requestCall(STORE_TRADE_CANCEL, $params, $callback);
    }
}