<?php
class ome_preprocess_crm{
    public $fenxiaowang = 'shopex_b2b';//分销王的店铺类型,需要检测订单类型
    private static  $__crm_gifts = array();
    
    #有些平台,erp中，object上存的bn可能是前端的id,所以处理赠品时object这层数据不能用，只能使用order_items表上的明细
    private static  $must_item_shop_type  = array('alibaba');
    
    #$type是重新强制请求CRM赠品的标示
    public function process($order_id,&$msg,$type=false){
        #获取crm基本配置
        $crm_cfg = app::get('crm')->getConf('crm.setting.cfg');
        #如果没有开启crm应用，程序返回
        //if(empty($crm_cfg)){
        //    return false;
        //}
        $operationLogObj = app::get('ome')->model('operation_log');
        $Obj_preprocess = app::get('ome')->model('order_preprocess');
        $opinfo = kernel::single('ome_func')->getDesktopUser();
        if(!$order_id){
            return false;
        }

        #检测是否开启赠品
        //if($crm_cfg['gift'] != 'on'){
        //    $msg = '订单没有开启CRM赠品';
        //    $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
        //    return false;
        //}
        $_rs = $Obj_preprocess->getList('preprocess_order_id',array('preprocess_order_id'=>$order_id,'preprocess_status'=>'1','preprocess_type'=>'crm'));
        #不为空，说明已经获取过CRM赠品
        if(!empty($_rs)){
            return true;
        }
        $orderObj = app::get('ome')->model('orders');
        $obj_channel = app::get('channel')->model('channel');
        
        #根据订单号，找到当前订单的相关信息
        $order_info = $obj_channel->getOrderInfo($order_id);
        
        //部分拆分或已拆分完的直接返回true
        if( in_array($order_info['process_status'],array('splitting','splited'))){
            return true;
        }
        #打标的状态
        $status = $order_info['abnormal_status'] | ome_preprocess_const::__HASCRMGIFT_CODE;
        
        $order_bn    = $order_info['order_bn'];#单号
        $shop_type    = $order_info['shop_type'];#店铺类型
        $shop_id       = $order_info['shop_id'];#店铺节点
        $receiver_name = $order_info['ship_name'];#收件人姓名
        $buyer_nick    = $order_info['uname'];#会员名
        $mobile        = $order_info['ship_mobile'] ? $order_info['ship_mobile'] : '';
        $tel           = $order_info['ship_tel'] ? $order_info['ship_tel'] : '';
        $ship_area     = $order_info['ship_area'];
        $ship_area_arr = '';
        if ($ship_area && is_string($ship_area)) {
            kernel::single('ome_func')->split_area($order_info['ship_area']);
            $ship_area_arr = $order_info['ship_area'];
        }
        $payed = $order_info['payed'] ?  $order_info['payed'] : 0;#付款金额
        $pay_time = $order_info['paytime'] ? $order_info['paytime'] : 0;#付款时间
        $isCod = $order_info['is_cod'] == 'true' ? 1 : 0;

        #检测当前订单的来源店铺否开启赠品
        $shop_shop_type = $this->shopex_shop_type();
        if($shop_shop_type[$shop_type]){
            $msg = 'shopex类型店铺，不支持CRM赠品处理';
            $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
            return false;
        }
        
        /* 获取订单明细 */
        if($crm_cfg && ($crm_cfg['gift'] == 'on'))
        {
            #第三方CRM赠品
            $order_item_info = $obj_channel->getOrderItemInfo($order_id);
        }
        else
        {
            $obj_order_objects    = app::get('ome')->model('order_objects');
            $obj_order_items      = app::get('ome')->model('order_items');
            
            #ERP本地赠品
            if(in_array($shop_type, self::$must_item_shop_type)){
                $order_item_info = $obj_order_items->getList('bn,name, nums as nums ,round(sale_price/nums,3) as price ',array('order_id'=>$order_id));
            }else{
                $order_item_info = $obj_order_objects->getList('bn,name, quantity as nums ,sale_price as price',array('order_id'=>$order_id));
            }
        }

       #检测完毕,调用赠品接口,获取赠品规则
       $params = array(
           'buyer_nick' => $buyer_nick,
           'receiver_name'=> $receiver_name,
           'mobile' => $mobile,
           'tel' => $tel,
           'shop_id' => $shop_id,
           'order_bn' => $order_bn,
           'province' => $ship_area_arr[0],
           'city' => $ship_area_arr[1],
           'district' => $ship_area_arr[2],
           'total_amount' => $order_info['total_amount'],
           'payed' => $payed,
           'createtime' => $order_info['createtime'],
           'pay_time' => $pay_time,
           'is_cod' => $isCod,
           'pay_status' => $order_info['pay_status'],
           'order_type' => $order_info['order_type'],
           'items' => $order_item_info
       );
       #强制重新请求的标示
       if($type){
           $params['is_send_gift'] = 1;
       }else{
           $params['is_send_gift'] = 0;
       }
       $obj_crm_rpc = kernel::single('crm_rpc_gift');
       #根据店铺节点、收件人、会员名、手机，获取赠品规则
       #如果绑定了crm，且crm赠品规则开启时 则调用crm赠品接口
        if(!empty($crm_cfg) && ($crm_cfg['gift'] == 'on')){

            $gift_rule = $obj_crm_rpc->getGiftRule($params);   // 请求crm接口

        } else {

            //两种情况：1.如果绑定crm，但是crm赠品规则未开启  2.如果没绑定crm，但是本地规则开启了 都直接调用本地的规则
            $gift_on_off = app::get('ome')->getConf('gift.on_off.cfg');

            if($gift_on_off == 'on'){

                $gift_rule = $obj_crm_rpc->getFormatRst($params);      // 调用本地方法

            } else {
                return true;
            }

        }

       if($gift_rule['result'] == 'succ'){
           #赠品数据为空
           if(empty($gift_rule['data'])){
               $msg = '订单CRM赠品数据为空';
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
           }
           if(!isset($gift_rule['data']['order_bn']) && isset($gift_rule['msg'])){
               if($gift_rule['msg']){
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $gift_rule['msg'],time(),$opinfo);
               }
               
               return false;
           }
           #CRM返回订单与发送赠品请求的订单号不一致
           if($gift_rule['data']['order_bn'] && $gift_rule['data']['order_bn'] != $order_bn){
               $msg = 'CRM返回订单号与请求单号不一致';
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
           }
           #订单天生没有赠品，则程序返回
           if(empty($gift_rule['data']['gifts'])){
               $msg = '订单CRM赠品为空';
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
           }
       }elseif($gift_rule['result'] == 'fail'){
           $msg = '订单CRM预处理:'.$gift_rule['msg'];
           if(($crm_cfg['gift'] != 'on') && !isset($crm_cfg['error'])){
               $dealways = app::get('ome')->getConf('gift.error.ways');
               #不添加赠品，继续审单发货
               if(empty($dealways) || ($dealways == 'off')){
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   return false;
               }elseif($dealways == 'on'){
                   #打标提醒，人工处理
                   $orderObj->update(array('abnormal_status'=>$status, 'auto_status' => 32768),array('order_id'=>$order_id));
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   #打标与记日志完成后，程序返回
                   return false;
               }
           } else {
               #不添加赠品，继续审单发货
               if($crm_cfg['error'] == 'off' ){
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   return false;
               }elseif($crm_cfg['error'] == 'on'){
                   #打标提醒，人工处理
                   $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   #打标与记日志完成后，程序返回
                   return false;
               }
           }
       }else{
           $msg = '订单CRM预处理出错';
           #打标提醒，人工处理
           $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
           $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
           #打标与记日志完成后，程序返回
           return false;
       } 
       
       #获取crm请求返回的所有gift_id
       $crm_gift_bn = array();
       $crm_gifts = $gift_rule['data']['gifts'];  #CRM这层结构：'gifts'=> array('bn1'=>1,'bn2'=>2,....)
       $crm_gift_bn = array_keys($crm_gifts);
       
       /* 获取赠品类型(普通商品、捆绑商品) */
       $giftObj    = app::get('crm')->model('gift');
       $giftList   = $giftObj->getList('gift_id, product_id, gift_bn', array('gift_bn'=>$crm_gift_bn));
       if(empty($giftList))
       {
           $msg    = 'CRM赠品不存在!';
           $operationLogObj->write_log('order_preprocess@ome', $order_id, $msg, time(), $opinfo);
           return false;
       }
       
       /* 检测是否有赠品已删除 */
       $erp_gift_bn    = array();
       foreach ($giftList as $key => $val)
       {
           $erp_gift_bn[]    = $val['gift_bn'];
       }
       
       #获取无法在淘管中对应的赠品货号
       $is_fail    = false;
       $diff_bn    = array_diff($crm_gift_bn, $erp_gift_bn);
       if($diff_bn){
           $is_fail = true;
       }
       
       $giftProductList    = array();
       foreach ($giftList as $key => $val)
       {
           $giftProductList[]    = $val['gift_bn'];
       }
       
       /* 检查普通商品是否存在 */
       $product_list    = array();
       if($giftProductList)
       {
           $obj_product    = app::get('ome')->model('products');
           $product_list   = $obj_product->getList('product_id,goods_id,bn,name', array('bn'=>$giftProductList));
           
           if(empty($product_list))
           {
               $msg = 'CRM赠品对应的商品不存在!';
               $operationLogObj->write_log('order_preprocess@ome', $order_id, $msg, time(), $opinfo);
               return false;
           }
       }
       
       #库存不足的,放在审单的地方处理,这里不再验证库存   
       
       
       //开启事务
       kernel::database()->exec('begin');
       
       /* 保存订单明细 */
       $is_update    = true;
       
       #普通商品
       if($is_update && $product_list)
       {
           $is_update    = $this->insert_order_item($product_list, 'normal', array('order_id'=>$order_id, 'order_bn'=>$order_bn, 'shop_id'=>$shop_id), $crm_gifts);
       }
       
       //销毁变量
       unset($giftProductList, $giftList, $product_list, $erp_gift_bn);
       
       /* 记录CRM预处理完成状态 */
       if($is_update){
         #赠品不对应的    
          if($is_fail){
              $str_bn = implode($diff_bn,',');
              $msg = 'CRM赠品'.$str_bn.'与ERP的赠品货号不对应,订单置为失败类型';
              $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
              #将订单状态改为失败订单
              $orderObj->update(array('is_fail'=>'true'),array('order_id'=>$order_id)); 
              $data_preprocess = array('preprocess_order_id'=>$order_id,'preprocess_type'=>'crm','preprocess_status'=>'1');
              $Obj_preprocess->save($data_preprocess);
              kernel::database()->commit();
              return true ;
          }
          $msg = '订单预处理CRM赠品完成';
          #记录CRM预处理完成状态
          $data_preprocess = array('preprocess_order_id'=>$order_id,'preprocess_type'=>'crm','preprocess_status'=>'1');
          $Obj_preprocess->save($data_preprocess);
          
          $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
          kernel::database()->commit();
          return true ;
      }else{
          kernel::database()->rollBack();

          $msg = '订单添加CRM赠品数据出错';
          $status = $order_info['abnormal_status'] | ome_preprocess_const::__HASCRMGIFT_CODE;
          #添加赠品出错的时候，继续审单发货
          if( $crm_cfg['error'] == 'off'){
              $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
              return false;
          }
          #添加赠品出错的时候，打标提醒，人工处理
          elseif( $crm_cfg['error'] == 'on'){
              $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
              $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
              #打标与记日志完成后，程序返回
              return false;
          }
      }
    }
    #shopex前端店铺列表
    function shopex_shop_type(){
        $shop = array(
                'shopex_b2b'=>'shopex_b2b',
                'shopex_b2c'=>'shopex_b2c',
                'ecos.b2c'=>'ecos.b2c',
                'ecshop_b2c'=>'ecshop_b2c',
                'ecos.dzg'=>'ecos.dzg'
        );
        return $shop;
    }
    
    /**
     * 插入订单明细
     * 
     * @param $product_list 商品列表
     * @param $type 类型(normal:普通商品, pkg:捆绑商品)
     * @param $order_info 订单信息
     * @param $crm_gifts 赠品信息
     * 
     * @return 
     */
    function insert_order_item($product_list, $type, $order_info, $crm_gifts)
    {
        $order_id    = $order_info['order_id'];
        $order_bn    = $order_info['order_bn'];
        $shop_id     = $order_info['shop_id'];
        
        if(empty($product_list) || empty($order_info) || empty($crm_gifts))
        {
            return false;
        }
        
        $orderItemObj      = app::get('ome')->model('order_items');
        $orderObjectObj    = app::get('ome')->model('order_objects');
        
        $obj_product       = app::get('ome')->model('products');
        $pkgProObj         = app::get('omepkg')->model('pkg_product');
        
        #货品对应店铺冻结
        $shopFreezeLib    = kernel::single('ome_shop_freeze');
        $shopFreezeLogLib    = kernel::single('ome_shop_freeze_log');
        
        #获取店铺冻结系统配置
        $is_shop_freeze_log    = $shopFreezeLogLib->get_product_shop_freeze_config();
        
        foreach($product_list as $objItem)
        {
            //pkg捆绑商品
            if($type == 'pkg')
            {
                $objItem['bn']    = $objItem['pkg_bn'];
            }
            
            $gift_num    = intval($crm_gifts[$objItem['bn']]);#CRM返回的赠品数量
            
            //obj层
            $tmp_obj = array(
                    'order_id' => $order_id,
                    'obj_type' => 'gift',
                    'shop_goods_id' => '-1',#CRM赠品类型标示
                    'goods_id' => $objItem['goods_id'],
                    'bn' => $objItem['bn'],
                    'name' => $objItem['name'],
                    'price' => 0.00,
                    'sale_price' => 0.00,
                    'pmt_price' => 0.00,
                    'amount' => 0.00,
                    'quantity' => $gift_num,
            );
            
            $result    = $orderObjectObj->save($tmp_obj);
            if(!$result)
            {
                return false;
            }
            
            /* order_item层数据处理 */
            $item_list    = array();
            if($type == 'pkg')
            {
                $item_list    = $pkgProObj->getList('product_id, bn, name, pkgnum', array('goods_id'=>$objItem['goods_id']));
            }
            else
            {
                $item_list[]    = $objItem;
            }
            
            foreach ($item_list as $key_i => $valItem)
            {
                #pkg捆绑商品数量
                if($type == 'pkg')
                {
                    $gift_num    = $gift_num * $valItem['pkgnum'];
                }
                
                $tmp_items = array(
                        'order_id' => $order_id,
                        'obj_id' => $tmp_obj['obj_id'],
                        'shop_goods_id' => '-1',#CRM赠品类型标示
                        'product_id' => $valItem['product_id'],
                        'shop_product_id' => '-1',#CRM赠品类型标示
                        'bn' => $valItem['bn'],
                        'name' => $valItem['name'],
                        'cost' => 0.00,
                        'price' => 0.00,
                        'amount' => 0.00,
                        'sale_price'=> 0.00,
                        'pmt_price' => 0.00,
                        'quantity' => $gift_num,
                        'sendnum' => 0,
                        'item_type' => 'gift',
                );
                
                $result    = $orderItemObj->save($tmp_items);
                if(!$result)
                {
                    return false;
                }
                
                $obj_product->chg_product_store_freeze($valItem['product_id'], $gift_num, "+");
                
                #[增加]货品店铺冻结 ExBOY
                $shopFreezeLib->freeze($shop_id, $valItem['product_id'], $gift_num);
                
                #店铺冻结增减明细日志
                if($is_shop_freeze_log)
                {
                    $shopFreezeLogLib->changeLog($shop_id, $valItem['product_id'], $gift_num, 7, '增加订单号:'. $order_bn .'上CRM赠品对应店铺冻结');
                }
            }
        }
        
        //销毁变量
        unset($orderItemObj, $orderObjectObj, $obj_product, $pkgProObj, $product_list, $order_info, $crm_gifts, $tmp_obj, $tmp_items, $item_list);
        
        return true;
    }
}