<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2010 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */
 
class pam_callback{

    function login($params){
        $auth = pam_auth::instance($params['type']);
        $auth->set_appid($params['appid']);
        if($params['module']){
            if($passport_module = kernel::single($params['module'])){
                if($passport_module instanceof pam_interface_passport){
                    $module_uid = $passport_module->login($auth,$auth_data);
                    if($module_uid){
                        $auth_data['account_type'] = $params['type'];
                        $auth->account()->update($params['module'], $module_uid, $auth_data);
                    }       
                    $log = array(
                        'event_time'=>time(),
                        'event_type'=>$auth->type,
                        'event_data'=>base_request::get_remote_addr().':'.$auth_data['log_data'],
                        
                    );
                    app::get('pam')->model('log')->insert($log);
                    if(!$module_uid)$_SESSION['last_error'] = $auth_data['log_data'];
                    $_SESSION['type'] = $auth->type;
                    $_SESSION['login_time'] = time();
                    if(!kernel::single('desktop_user')->checkPassword($_POST['password'])) {
                        $_SESSION['needChangePassword'] = '由于密码过于简单，请先修改密码。密码长度不小6位，需包含数字和字母';
                    } else {
                        $_SESSION['needChangePassword'] = null;
                    }
                    $params['member_id'] = $_SESSION['account'][$params['type']];
                    $params['uname'] = $_POST['uname'];

                    foreach(kernel::servicelist('pam_login_listener') as $service)
                    {
                        $service->listener_login($params);
                    }

                    // 登陆御城河
                    kernel::single('base_hchsafe')->login_log($params);

                    if($params['redirect'] && $module_uid) {
                        $service = kernel::service('callback_infomation');
                        if (is_object($service)) {
                            if (method_exists($service, 'get_callback_infomation') && $module_uid) {
                                $data = $service->get_callback_infomation($module_uid, $params['type']);
                                if (!$data) $url = '';
                                else $url = '?' . utils::http_build_query($data);
                            }

                        }
                    }
                    if($module_uid) {
                        // 登录成功，御城河风险系统评估
                        $risk = kernel::single('base_hchsafe')->compute_risk($params['uname'],$msg);
                        error_log(var_export($risk,1),3,__FILE__.'.log');
                        if (!$risk) {
                            unset($_SESSION['account'][$auth->type]);
                            $_SESSION['last_error'] = $msg;
                        }
                    }

                    if($_COOKIE['autologin'] > 0){
                        kernel::single('base_session')->set_cookie_expires($_COOKIE['autologin']);
                        //如果自动登录，设置cookie过期时间，单位：分
                    }
                    
                    if($_SESSION['callback'] && !$module_uid){
                        $callback_url = $_SESSION['callback'];
                        unset($_SESSION['callback']);
                        header('Location:' .urldecode($callback_url));
                        exit;
                    }
                     else{
                         if($params['redirect']){
                             $redirect = base64_decode(urldecode($params['redirect']));
                         }
                         $redirect = preg_match('/http:\/\/[\w.]+[\w\/]*[\w.]*\??[\w=&\+\%]*/is',$redirect) ? $redirect : app::get('desktop')->router()->gen_url(array(),1);
                         header('Location:' .$redirect. $url);
                         exit; 
                     }
                          
                }
            }else{
               
            }
        }
    }

}
