<?php
/**
 * 发货的队列调用
 *
 * @access public
 * @author wangbiao<wangbiao@shopex.cn>
 * @version $Id: consign.php 2016-10-13
 *
 */
class wms_delivery_consign{

    function __construct($app)
    {
        $this->app = $app;
    }
    
    /**
     * 发货放队列
     *
     * @return void
     * @author 
     **/
    public function push_queue($params)
    {
        // 多队列(注意：其它多队列是：defined('SAAS_COMBINE_MQ'))
        if (defined('SAAS_CONSIGN_MQ') && SAAS_CONSIGN_MQ == 'true')
        {
            $data = array();
            $data['spider_data']['url'] = kernel::openapi_url('openapi.autotask','service');
            
            $push_params = array(
                    'log_text'  => $params['log_text'],
                    'log_id'    => $params['log_id'],
                    'task_type' => 'autodly',
            );
            $push_params['sign'] =  taskmgr_rpc_sign::gen_sign($push_params);
            foreach ($push_params as $key => $val) {
                $postAttr[] = $key . '=' . urlencode($val);
            }
            
            $data['spider_data']['params']    = empty($postAttr) ? '' : join('&', $postAttr);
            $data['relation']['to_node_id']   = base_shopnode::node_id('ome');
            $data['relation']['from_node_id'] = '0';
            $data['relation']['tid']          = $params['log_id'];
            $data['relation']['to_url']       = $data['spider_data']['url'];
            $data['relation']['time']         = time();
            
            $routerKey = 'tg.order.consign.'.$data['nodeId'];
            
            $message = json_encode($data);
            $mq = kernel::single('base_queue_mq');
            
            //注意：其它多队列是：$GLOBALS['_MQ_COMBINE_CONFIG'], 'TG_COMBINE_EXCHANGE', 'TG_COMBINE_QUEUE')
            $mq->connect($GLOBALS['_MQ_CONSIGN_CONFIG'], 'TG_CONSIGN_EXCHANGE', 'TG_CONSIGN_QUEUE');
            $mq->publish($message, $routerKey);
            $mq->disConnect();
        }
        else 
        {
            // 单队列
            $push_params = array(
                    'data' => array(
                            'log_text' => $params['log_text'],
                            'log_id' => $params['log_id'],
                            'task_type' => 'autodly',
                    ),
                    'url' => kernel::openapi_url('openapi.autotask','service')
            );
            kernel::single('taskmgr_interface_connecter')->push($push_params);
        }
        
        return true;
    }
}